apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "surrealdb.fullname" . }}
  labels:
    {{- include "surrealdb.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "surrealdb.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "surrealdb.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "surrealdb.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          {{- with .Values.command }}
          command:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with .Values.args }}
          args:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          env:
            - name: SURREAL_NO_BANNER
              value: "true"
            - name: SURREAL_PATH
              value: {{ .Values.surrealdb.path }}
            - name: SURREAL_LOG
              value: {{ .Values.surrealdb.log }}
            - name: SURREAL_BIND
              value: 0.0.0.0:{{ .Values.surrealdb.port }}
            {{- with .Values.surrealdb.initial_user }}
            - name: SURREAL_USER
              value: {{ . }}
            {{- end }}
            {{- with .Values.surrealdb.initial_pass }}
            - name: SURREAL_PASS
              value: {{ . }}
            {{- end }}
            - name: SURREAL_AUTH
              value: "{{ .Values.surrealdb.auth }}"
            {{- with .Values.surrealdb.object_cache }}
            - name: SURREAL_OBJECT_CACHE
              value: {{ . }}
            {{- end }}
            {{- with .Values.surrealdb.object_store }}
            - name: SURREAL_OBJECT_STORE
              value: {{ . }}
            {{- end }}
          ports:
            - name: http
              containerPort: {{ .Values.surrealdb.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /health
              port: http
          readinessProbe:
            httpGet:
              path: /health
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}   
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
